;=================================================                
;SCRbyte.asm (scherm manipulatie op byte-niveau)
;(c)1994  Wagemakers Staf
;=================================================                
		.MODEL SMALL
		.CODE
		PUBLIC readbyte
;--------------------------------------------
;Leest een byte van het grafisch scherm
;aanroep : bx,ax plaats byte (pixels)
;antwoord: al,ah,bl,bh -> bl,gr,rood,inten
;--------------------------------------------
readbyte        PROC NEAR
		push cx
		push dx
		push si
		push es
		call byteaddr
		mov si,bx
		mov dx,03ceh
		mov ax,0005h
		out dx,ax
		mov ax,0304h
rb01:           out dx,ax
		mov bh,es:[si]
		dec ah
		out dx,ax 
		mov bl,es:[si]
		dec ah
		out dx,ax
		mov ch,es:[si]
		dec ah
		out dx,ax
		mov cl,es:[si]
		mov ax,cx
		pop es
		pop si
		pop dx
		pop cx
		ret
readbyte        ENDP
;-------------------------------------------------
;stel de werking van getbyteblock & putbyteblock
;al    = 000 exakte kopie naar het geheugen (add)
;al    = 001 begin op de geheugen plaats
;DS:BX = pointer naar de parameters
;cx,dx = extra geheugen offset
;-------------------------------------------------
		PUBLIC setgbb
setgbb          PROC    NEAR
		mov byte ptr ds:[gbbmode],al
		mov word ptr ds:[gbbpar],bx
		ret
setgbb          ENDP
		PUBLIC getbyteblock
;-------------------------------------------------
;Kopieert naar het geheugen
;ax = begin x-byte   cx = aantal x-bytes
;bx = begin y-pixel  dx = aantal y-pixels
;di,si = x,y geh extra gehoffset
;-------------------------------------------------
getbyteblock    PROC
		push ax
		push bx
		push cx
		push dx
		push si
		push di
		push ds   
		push es   
		push dx
		mov  dx,0
		call gehoff_ok
		pop  dx
		inc cx
		inc dx
		mov word ptr ds:[x0],ax
		mov word ptr ds:[lx],cx
		mov word ptr ds:[y0],bx
		mov word ptr ds:[ly],dx
		mov dx,03ceh
		mov ax,0005h
		out dx,ax
		mov ax,word ptr ds:[x0]
		push dx
		mov  dx,0
		call byteaddr
		pop  dx
		mov  si,bx
		mov  bx,word ptr ds:[gbbpar]
		mov  ax,0304h
gbb01:
		out dx,ax
		push ax
		push bx
		mov  ax,[bx]
		mov  es,ax
		add  bx,8
		mov  di,[bx]
		cmp  word ptr ds:[gbbmode],0
		jne  gbbmode_is_1
		add  di,si
gbbmode_is_1:                
		add  di,word ptr ds:[gbboff]
		pop  bx
		add  bx,2
		pop  ax
		call scr_to_mem
		dec ah
		jns gbb01
		pop es
		pop ds
		pop di
		pop si
		pop dx
		pop cx
		pop bx
		pop ax
		ret
getbyteblock    ENDP
;--------------------------------------------
;Zet de geh. offset juist!
;--------------------------------------------
gehoff_ok       PROC
		push ax
		push bx
		mov  bx,si
		mov  ax,di
		call byteaddr
		mov  word ptr ds:[gbboff],bx
		pop  bx
		pop  ax
		ret
gehoff_ok       ENDP
;--------------------------------------------
;video schrem -> virtueel scherm!
;--------------------------------------------
scr_to_mem      PROC
		push ax
		push cx
		push si
		push di
		push ds

		mov  cx,word ptr ds:[ly]
		mov  ax,word ptr ds:[lx]
		push ax
		mov  ax,0A000h
		mov  ds,ax
		pop  ax
y_loop:
		push cx
		mov  cx,ax
		push di
		push si
		shr  cx,1
		pushf
		cmp  cx,0
		je   een_byte
		rep  movsw
een_byte:       popf
		jnc geen_byte
		movsb
geen_byte:      pop  si
		pop  di
		add  si,cs:[bytesperlijn]
		add  di,cs:[bytespervlijn]
		pop  cx
		loop y_loop

		pop ds
		pop di
		pop si
		pop cx
		pop ax
		ret
scr_to_mem      ENDP
		PUBLIC byteaddr
;--------------------------------------------
;berekent het adres van een byte
;aanroep  : ax = x / bx = y  
;           dx = 0 -> in grafisch scherm    
;                1 -> in virtueel scherm
;antwoord : bx = adres
;--------------------------------------------
byteaddr        PROC
		push ax
		push dx
		push cx
		
		push ax
		mov  ax,bx
		cmp  dx,0
		jne  byteaddr01
		mov  cx,cs:[bytesperlijn]
		jmp  byteaddr02
byteaddr01:     mov  cx,cs:[bytespervlijn]                
byteaddr02:     xor  dx,dx
		mul  cx
		pop  bx
		add  bx,ax
		pop  cx
		pop  dx
		pop  ax   
		ret
byteaddr        ENDP
;--------------------------------------------
;geh --> scherm
;ax = begin x-byte   cx = aantal x-bytes
;bx = begin y-pixel  dx = aantal y-pixels
;di = begin x-byte  in Virtueel scherm.
;si = begin y-pixel in Virtueel scherm.
;--------------------------------------------
		PUBLIC putbyteblock
putbyteblock    proc
		push ax
		push bx
		push cx
		push dx
		push si
		push di
		push ds   
		push es   
		inc dx         ;1 y-pixel te weinig!
		inc cx         ;1 x-byte te weinig!
		push dx        ;Bewaar y-pixels op stapel.
		mov  dx,1      ;In virteel scherm!
		call gehoff_ok ;[gbboff] = beginadres 
		mov  dx,0      ;In video scherm!
		call byteaddr  ;BX = beginadres     
		pop  dx        ;Haal aantal x-bytes van de stapel
		mov  di,bx     ;di = adres beginbyte
		mov  bx,cx     ;bx = xbytes
		mov  cx,dx     ;cx = ypixels
		call vscr_to_scr
		mov ax,0ff02h
		mov dx,03c4h
		out dx,ax
		pop es
		pop ds
		pop di
		pop si
		pop dx
		pop cx
		pop bx
		pop ax
		ret
putbyteblock    endp
;--------------------------------------------
;Haal de adres waarde op van een bepaald
;virtueel bitvlak!
;aanroep: 
;AH = bitvlaknummer
;     8 = intensiteit   4 = rood  
;     2 = groen         1 = blauw  
;ES = @data
;antwoord: DS:SI = beginadres
;--------------------------------------------
VSCRad          proc
		push bx
		mov bx,ES:[gbbpar]  ;haal wijzer naar wijzers!
		cmp ah,8            ;bitvlak 1???
		je VSCRad01
vad_g8:         cmp ah,4            ;bitvlak 2???
		jne vad_g4
		add bx,2            ;wijzer op bitvlak 2!
		jmp VSCRad01
vad_g4:         cmp ah,2            ;bitvlak 3???
		jne vad_g2
		add bx,4            ;wijzer op bitvlak 3!
		jmp VSCRad01
vad_g2:         add bx,6            ;wijzer op bitvlak 1!
VSCRad01:       mov si,ES:[BX]      ;Haal seg. adres van
		mov ds,si           ;het virtueel bitvlak!
		mov si,ES:[BX+8]    ;Haal offset adres v. vbitvl.!
		pop bx
		ret
VSCRad          ENDP
;--------------------------------------------
;video geheugen  -> virtueel scherm
;BX = xbytes     [gbboff] = offset vscherm
;CX = ypixels     DI = offset video scherm
;--------------------------------------------
VSCR_TO_SCR     PROC
		push ax
		push cx
		push dx
		push si
		push di
		push ds
		push es

		push ds             ;DS =
		pop es              ;ES!
		mov si,0
VSCR2SCR02:     mov ah,8            ;AH = bitvlak 1 ...
		push cx             ;
VSCR2SCR01:     mov  al,2
		mov  dx,03C4h
		out  dx,ax
		push bx
		push si
		call VSCRad         ;DS:SI ->begin VSCR
		pop  bx
		add  si,bx          ;DS:SI ->huidige positie
		pop bx
		cmp  es:[gbbmode],0 ;mode = 0???
		jne  vs_mode_is_1
		add  si,di          ;JA, dus offset aanpassen ...
vs_mode_is_1:   add si,es:[gbboff]  ;SI = SI + offset vscherm.
		mov  cx,bx          ;CX = Xbytes
		push es             ;Data segment op stapel...
		mov  dx,0A000h
		mov  es,dx          ;ES = Video segment.
		push si             ;Vscherm positie op stapel... 
		push di             ;Scherm positie op staple... 
		shr cx,1            ;Delen door 2 voor movsw (sneller!).
		pushf               ;Carry op stapel...
		cmp cx,0            ;Deling kleiner 
		je  v2scr_byte_move ;dan 1???
		rep movsw           ;Nee, ok dan schrijven.
v2scr_byte_move:popf                ;Carry van stapel halen.
		jnc v2scr_move_ok   ;Hebben we een rest???
		movsb               ;Ja, dus nog eens schrijven!
v2scr_move_ok:  pop di              ;Scherm +
		pop si              ;Vscherm positie van stapel.
		pop es              ;ES = data segment.
		sub si,es:[gbboff]  ;SI terug op begin waarde.
		clc                 ;AH klaar maken 
		rcr ah,1            ;voor volgend bitvlak...
		jnc VSCR2SCR01      ;Laaste bitvlak bereikt???
		pop cx              ;Haal nog te schrijven ypixels van stapel.
		add di,cs:[bytesperlijn] ;DI &
		add si,cs:[bytespervlijn];SI klaar voor volgende rij.
		loop VSCR2SCR02          ;Schrijf volgende rij!
		pop es
		pop ds
		pop di
		pop si
		pop dx
		pop cx
		pop ax
		ret
VSCR_to_SCR     ENDP
;--------------------------------------------
;video geheugen  -> virtueel scherm
;BX = xbytes     SI = offset virtueel scherm
;DX = ypixels    DI = offset video scherm
;AH = bitvlaknummer
;     8 = intensiteit   4 = rood  
;     2 = groen         1 = blauw  
;--------------------------------------------
		PUBLIC mem_to_scr
mem_to_scr      proc
		push dx
		push es
		push ax
		mov ax,0a000h
		mov es,ax
		pop ax
		push di
		push cx
m2scr01:
		push di
		push si
		push cx
		mov  cx,bx
		mov al,02
		mov dx,03c4h
		out dx,ax
		shr cx,1
		pushf
		cmp cx,0
		je  byte_move
		rep movsw
byte_move:      popf
		jnc geen_byte_move
		movsb
geen_byte_move: pop cx
		pop si
		pop di
		add di,cs:[bytesperlijn]
		add si,cs:[bytespervlijn]
		loop m2scr01
		pop cx
		pop di
		pop es
		pop dx
		ret
mem_to_scr      endp
;--------------------------------------------
;zet een bepaalde waarde in het geh
;--------------------------------------------
		PUBLIC set_mem
set_mem         PROC
		push bx
		push cx
		push di
		mov bx,word ptr ds:[gbbpar]
		mov cx,4
set_mem01:      push cx
		push bx
		mov  di,[bx]
		mov  es,di
		add  bx,8
		mov  di,[bx]
		pop  bx
		add  bx,2
		mov  cx,dx
		rep  stosb
		pop  cx
		loop set_mem01
		pop  di
		pop  cx
		pop  bx
		ret
set_mem         ENDP
PUBLIC          bytesperlijn
PUBLIC          bytespervlijn
bytesperlijn    dw ?
bytespervlijn   dw ?
		.DATA?
gbbmode         db ?
gbbpar          dw ?
x0              dw ?
y0              dw ?
lx              dw ?
ly              dw ?
gbboff          dw ?
		END
