                .MODEL SMALL
                .CODE
;------------------------------------------------------------------------
;Stelt de werking van toon_PCX in
;aanroep : mode 
;          al = 0 toon PCX op het scherm, de proc bepaalt zelf de
;                 scherm resolutie.
;          al = 1 laad de PCX in het geheugen 
;                 (enkel 256kl, niet meer dan 64k )
;          seg,offset 
;          bx = het segmentadres waarin de info geplaast wordt. 
;-----------------------------------------------------------------------
                PUBLIC toon_pcx_init
toon_pcx_init   PROC NEAR
                mov  cs:[mode],al
                mov  cs:[vir_seg],bx
                ret
toon_PCX_init   ENDP
;---------------------------------------------;
;Zet DI:SI op het volgende segment ...
;---------------------------------------------;
ds_ok           PROC NEAR
                push ax
                mov  ax,ds
                add  ax,01000h
                mov  ds,ax
                inc  si
                pop  ax
                ret
ds_ok           ENDP
;---------------------------------------------;
;Stelt een bepaalde kleur in.
;aanroep:  call palet
;          BX    : kleurnummer
;          CH    : waarde voor groen
;          CL    : waarde voor blauw
;          DH    : waarde voor rood
;---------------------------------------------;
palet           PROC NEAR
                push bx
                mov  ax,1007h
                int  10h
                mov  bl,bh
                mov  ax,1010h
                int  10h
                pop  bx
                ret
palet           ENDP
;---------------------------------------------;
;Openen van een bestaande file
;aanroep:  call open_bestand
;          DS:DX : filenaam
;          AL    : 0 -> lezen
;                  1 -> schrijven 
;                  2 -> lezen/schrijven
;antwoord: CF = 0 -> ok!
;          CF = 1 -> fout     
;            AX bevat foutkode   
;---------------------------------------------;
open_bestand    PROC NEAR
                push cx
                xor cx,cx
                mov ah,3Dh
                int 21h
                mov word ptr cs:[filehandle],ax
                pop cx
                ret
open_bestand    ENDP
filehandle      dw ?
;---------------------------------------------;
;Lezen uit een geopend bestand
;aanroep : call lees_bestand
;          cx    = aantal te lezen bytes
;          DS:DX = wijzer aan databuffer
;antwoord: CF = 0 -> OK! AX = aantal lezen bytes
;          CF = 1 -> fout! AX = foutkode     
;---------------------------------------------;
lees_bestand    PROC NEAR
                push bx
                mov bx,word ptr cs:[filehandle]
                mov ah,3fh
                int 21h
                pop bx
                ret
lees_bestand    ENDP
;---------------------------------------------;
;Sluiten van het geopend bestand
;aanroep : call sluit_bestand
;antwoord: CF = 0 -> OK!
;          CF = 1 -> fout AX = foutkode
;---------------------------------------------;
sluit_bestand   PROC NEAR   
                push ax
                push bx
                mov  bx,word ptr cs:[filehandle]
                mov  ah,3Eh
                int  21h
                pop  bx
                pop  ax
                ret
sluit_bestand   ENDP
;---------------------------------------------;
;Geeft de bestand_lengte weer!
;aanroep : call bestand_lengte
;antwoord: DX:AX -> dubbel woord
;---------------------------------------------;
bestand_lengte  PROC NEAR
                push bx
                push cx
                mov  bx,word ptr cs:[filehandle]
                xor  cx,cx       ;wijzer op begin van
                xor  dx,dx       ;de file zetten
                mov  al,2        ;tot het einde van de file
                mov  ah,42h      ;
                int  21h         ;"SEEK"
                push ax
                push dx
                pushf
                xor al,al        ;begin file 
                xor cx,cx        ;wijzer op begin van
                xor dx,dx        ;de file zetten
                mov ah,42h
                int 21h
                popf
                pop  dx
                pop  ax
                pop  cx
                pop  bx
                ret
bestand_lengte  ENDP
                PUBLIC lees_PCX
;----------------------------------------------
;Leest een PCX-bestand in het geheugen ...
;aanroep : DS:DX -> naam
;antwoord: CF = 0 -> ok!
;          CF = 1 -> fout.
;             ax = foutkode
;                  01 = Kan bestand niet openen
;                  02 = Te weinig geheugen
;                  03 = Leesfout!
;                  04 = Geen PCX-bestand.
;----------------------------------------------
lees_PCX        PROC NEAR                
                push bx
                push cx
                push dx
                push si
                push ds
                push di
                push es
                mov  word ptr cs:[aantal_seg],0
                mov  word ptr cs:[aantal_bytes],0
                mov  al,0           ;Open een bestaand
                call open_bestand   ;bestand.
                jnc  open_ok        ;Fout???? Nee, dan open_ok
                mov  ax,1           ;Ja, ax = foutkode.
                jmp  lpcx_fout
open_ok:        call bestand_lengte ;DX:AX is lengte bestand
                mov cx,4            ;Reken 
deel16:         clc                 ;DX:AX om
                rcr  dx,1           ;naar
                rcr  ax,1           ;aantal 
                loop deel16         ;paragraven.
                mov  bx,ax
                add  bx,2           ;aanvraag tot
                mov  ah,48h         ;bezetten van
                int  21h            ;geheugen ("memory allocate")
                jnc  geh_ok         ;Fout??? Nee, dan geh_ok.
                mov  ax,2           ;Ja, AX = foutkode.
                jmp  lpcx_fout
geh_ok:         mov  cs:[begin_seg],ax ;Bewaar segadres van PCX.
                mov  ds,ax             ;DS:DX
                mov  dx,0              ;-> PCX.
start_lezen:
                mov  cx,0FFFFh      ;Laad 64k
                call lees_bestand   ;in het geheugen.
                jnc  lees_ok        ;Fout??? Nee, dan lees_ok.
                mov  ax,3           ;Ja! AX is foutkode.
                jmp  lpcx_fout
lees_ok:        cmp  ax,0           ;Gedaan met lezen???
                je   lezen_gedaan   ;Ja, dan lezen_gedaan.
                cmp  ax,0FFFFh      ;64k inladen???
                jb   geen_64k       ;Nee, dan geen_64k.
                mov  ax,ds          ;Zet DS
                add  ax,01000h      ;op het volgende
                mov  ds,ax          ;segmentadres.
                inc  cs:[aantal_seg];++aantal_seg.
                jmp  start_lezen    ;Begin opnieuw te lezen.
geen_64k:       add  dx,ax          ;DS:DX klaar voor volgende leesaktie.
                mov  cs:[aantal_bytes],ax 
                jmp  start_lezen
geen_pcx:       mov  ax,4           ;Geen PCX ... AX=foutkode.
lpcx_fout:      stc                 ;CF=1 (fout).
                jmp  lpcx_ok        ;Verlaat procedure ...
lezen_gedaan:   push cs
                pop  ds
                call sluit_bestand  ;Sluit het bestand.
                mov  ax,cs:[begin_seg]   ; DS ->
                mov  ds,ax               ; pcx segment
                cmp  byte ptr ds:[0],10  ; Is het
                jne  geen_pcx            ; ingeladen 
                cmp  byte ptr ds:[2],1   ; bestand
                jne  geen_pcx            ; wel een
                cmp  byte ptr ds:[64],0  ; PCX???
                jne  geen_pcx            ; Nee, dan geen_pcx.
                clc                      ; Geen fout dus CF=0.
lpcx_ok:        pop  es
                pop  di
                pop  ds
                pop  si
                pop  dx
                pop  cx
                pop  bx
                ret
lees_PCX        ENDP
;--------------------------------------------------------
;Toont een PCX in op scherm ...
;Aanroep : call toon_PCX
;Antwoord: CF = 0 -> ok!
;          CF = 1 -> fout
;             AX = foutkode
;                  0 -> te veel bitvlakken ...
;                  1 -> videokaart heeft geen VESAbios
;                  2 -> videokaart ondersteund 640x480 256kl niet
;--------------------------------------------------------
                PUBLIC toon_PCX
toon_PCX        PROC NEAR
                push bx
                push cx
                push dx
                push si
                push ds
                push di
                push es
                mov  word ptr cs:[xteller],0
                mov  word ptr cs:[yteller],0
                mov  ax,cs:[begin_seg]
                mov  ds,ax
                call PCX_info
                mov  al,cs:[bitvlakken]
                cmp  al,4                ; bewaren!!!
                jbe  bitvl_ok
                mov  ax,0
tpcx_fout:      stc
                jmp  tpcx_einde
bitvl_ok:       mov  al,ds:[3]
                mov  cs:[bits_per_pixel],al
                cmp  al,8
                jb   geen_256kl
                cmp  word ptr cs:[x],320
                ja   r01
                cmp  word ptr cs:[y],200
                ja   r01
                cmp  byte ptr cs:[mode],1
                je   niet_naar_13
                mov  ax,13h
                int  10h
niet_naar_13:
                mov  cs:[bytes_per_lijn],320
                jmp  resolutie_ok
geen_vesa:      mov  ax,1
                jmp  tpcx_fout
heeft_res_niet: mov  ax,2 
                jmp  tpcx_fout
r01:            mov  ax,4F02h
                mov  bx,100h
                int  10h
                cmp  al,4fh
                jne  geen_vesa
                cmp  ah,0
                jne  heeft_res_niet
                mov  cs:[bytes_per_lijn],640
                jmp  resolutie_ok
geen_256kl:     mov  ax,12h              ; Ga naar 
                int  10h                 ;         VGA!
                mov  cs:[bytes_per_lijn],80
resolutie_ok:   mov  si,16               ; DS:SI -> kleur palet.
                mov  bx,0
                mov  cx,16
                cmp  cs:[bitvlakken],1
                je   geen_palet
kleur01:        push cx
                mov  ch,[si+1]           ; waarde voor groen.
                mov  cl,[si+2]           ;   "     "   blauw.
                mov  dh,[si]             ;   "     "    rood.
                SAR  cl,1
                SAR  cl,1
                SAR  ch,1
                SAR  ch,1 
                SAR  dh,1
                SAR  dh,1
                call palet               ; pas de kleur aan.
                add  si,3                ; SI klaar voor volgende kl.
                inc  bx                  ; BX   "     "     "     "
                pop  cx
                loop kleur01
geen_palet:     mov  si,0                ; DS:SI -> PCX bestand.
                cmp  byte ptr cs:[mode],0
                je   tpcx_mode0
                cmp  cs:[bitvlakken],1
                jne  tpcx_mode0
                cmp  byte ptr cs:[bits_per_pixel],8
                jne  tpcx_mode0
                mov  ax,cs:[vir_seg] 
                mov  es,ax
                mov  ax,cs:[x]
                mov  es:[0],ax
                mov  cs:[bytes_per_lijn],ax
                mov  ax,cs:[y]
                mov  es:[2],ax
                mov  di,4
                jmp  tpcx_mode1
tpcx_mode0:     mov  ax,0a000h           ; ES:DI
                mov  es,ax               ; ->
                mov  di,0                ; videogeheugen.
tpcx_mode1:     mov  si,80h              ; DS:SI -> tekening data.
                cmp  cs:[bitvlakken],1   ; monochroom???
                jne  kl01
                mov  bx,0F02h
                jmp  mono01
kl01:           mov  bx,0102h            ; reg voor kl. bank selektie.
mono01:         cmp  cs:[bits_per_pixel],8
                je   start_tekenen
                mov  ax,bx               ; Selektie de
                mov  dx,03c4h            ; eerste  de 
                out  dx,ax               ; kleurbank (blauw).
start_tekenen:  mov  al,[si]
                inc  si
                jnz  ds01 
                call ds_ok
ds01:           cmp  al,192
                jb   niet_comp
                mov  ah,[si] 
                inc  si
                jnz  ds02
                call ds_ok
ds02:
                mov  ch,0
                mov  cl,al
                and  cl,3fh              ; CX is aantal keer te herhalen.
                mov  al,ah               ; al is te-herhalen-byte.
                add  cs:[xteller],cx     ; Xteller in orde maken.
                rep  stosb               ; Schrijf naar videogeheugen.
                jmp  naar_loop           ; Overloop ??? Nee, dan ...
volgende_bank:  cmp  cs:[bitvlakken],1   ; Monochroom????
                jne  kleur02
                sub  di,cs:[xteller]
                cmp  cs:[bits_per_pixel],8
                jne  geen_256kl01
                add  di,cs:[bytes_per_lijn]
                jmp  di_ok
geen_256kl01:   add  di,cs:[bytes_per_lijn]
di_ok:          mov  word ptr cs:[xteller],0
                inc  cs:[yteller]
                jmp  loop_lus01
kleur02:        sub  di,cs:[xteller]     ; di klaar voor volgende kleur.
                mov  word ptr cs:[xteller],0; xteller is nul.
                shl  bh,1                ; bh voor volgende kleur.
                cmp  bh,10h
                jb   bank_selektie       ; Alle, kleuren gehad??? Nee,dan ...
                add  di,cs:[bytes_per_lijn] ; Ja! Di klaar voor volgende rij.
                inc  cs:[yteller]        ; ++y.
                mov  bh,1                ; bh = blauw.
bank_selektie:  cmp  cs:[bits_per_pixel],8
                je   jmp_loop_lus01
                mov  ax,bx               ; selekteer de juiste
                out  dx,ax               ; kleurbank.
jmp_loop_lus01: jmp  loop_lus01
niet_comp:      inc  cs:[xteller]
                stosb                    ; Niet gekomp., dus gewoon schrijven. 
                jmp  naar_loop           ; Overloop??? Nee, dan ...
naar_loop:      mov  ax,cs:[xbytes]
                cmp  word ptr cs:[xteller],ax ; Einde regel bereikt???
                jae  volgende_bank             ; Ja, selekteer volgende kl.
loop_lus01:     mov  ax,cs:[yteller]           ; Einde 
                cmp  ax,cs:[y]                 ; tekenning???
                ja   is_het_gedaan             ; Ja, stop dan.
                jmp  start_tekenen
is_het_gedaan:  cmp  cs:[bitvlakken],1 
                jne  tpcx_ok
                cmp  cs:[bits_per_pixel],8
                jne  tpcx_ok
                mov  bx,0
geen_0c:        lodsb
                cmp  al,0ch
                jne  geen_0c
palet256:       mov  dx,968                
                mov  al,bl
                out  dx,al
                mov  al,[si]
                mov  dx,969
                sar  al,1
                sar  al,1
                out  dx,al
                mov  al,[si+1]
                sar  al,1
                sar  al,1
                out  dx,al
                mov  al,[si+2]
                sar  al,1
                sar  al,1
                out  dx,al
                add  si,3
                inc  bl
                jnz  palet256
tpcx_ok:        mov  es,cs:[begin_seg]
                mov  ah,49h
                int  21h
                clc
tpcx_einde:     pop  es
                pop  di
                pop  ds
                pop  si
                pop  dx
                pop  cx
                pop  bx
                ret
toon_PCX        ENDP
;--------------------------------------------
;Geeft info over de PCX in het geheugen ...
;aanroep :CS:[begin] -> pcx
;antwoord:CS:SI -> info
;                  woord : aantal x pixels 
;                  woord : aantal y pixels
;                  woord : aantal x bytes
;                  byte  : aantal bitvlakken     
;                  byte  : aantal bits per pixel
;--------------------------------------------
PUBLIC PCX_info
PCX_info        PROC NEAR
                push ax
                push bx
                push ds
                mov  ax,cs:[begin_seg]
                mov  ds,ax
;-------------- init voor pcx-bestand -----------------------
                mov  ax,ds:[4]        
                mov  bx,ds:[8]           ; cs:[x]
                sub  bx,ax               ; is aantal
                mov  cs:[x],bx           ; x - pixels.
                mov  ax,ds:[6]
                mov  bx,ds:[10]          ; cs:[x]
                sub  bx,ax               ; is aantal
                mov  cs:[y],bx           ; y - pixels.
                mov  ax,ds:[66]          ; cs:[xbytes] is
                mov  cs:[xbytes],ax      ; lengte in bytes.
                mov  al,byte ptr ds:[65] ; aantal
                mov  cs:[bitvlakken],al  ; bitvlakken bewaren
                mov  si,offset x
                pop  ds
                pop  bx
                pop  ax
                ret
PCX_info        ENDP
PUBLIC  dump_pcx
dump_pcx        PROC
;-----------------------------------------
;aanroep:  ES = segment
;          BX = aantal paragraven
;antwoord: CF = 0 -> OK
;          CF = 1 -> fout!
;             BX = max aantal par.
;             AX = Fout kode
;                07 = geh. krotronle blok vernietigd
;                08 = te weinig geheugen
;                09 = foutief geh. blok adres
;-----------------------------------------
                push ax
                push bx
                push es
                xor  bx,bx
                mov  ax,word ptr cs:[begin_seg]
                mov  es,ax
                mov  ah,4ah
		int  21h
                pop  es
                pop  bx
                pop  ax
                ret
dump_pcx        ENDP                
PUBLIC          Begin_seg
PUBLIC          Bytes_per_lijn
aantal_seg      dw ?
aantal_bytes    dw ?
bytes_per_lijn  dw ?
begin_seg       dw ?
xteller         dw ?
yteller         dw 0
mode            db 0
vir_seg         dw ?
x               dw ?                
y               dw ?
xbytes          dw ?
bitvlakken      db ?
bits_per_pixel  db ?
                END
